// This claas was created by JaTiTV


package de.jatitv.opsecurity.config.languages;

import de.jatitv.opsecurity.Util;
import de.jatitv.opsecurity.system.Main;
import net.t2code.lib.Spigot.Lib.messages.send;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

public class LanguagesCreate {

    public static void messagesCreate() {
        send.debug(Main.plugin,"§4Language files are created / updated...");
        Long long_ = Long.valueOf(System.currentTimeMillis());

        File messagesDE = new File(Main.getPath(), "languages/german_messages.yml");
        YamlConfiguration yamlConfigurationDE = YamlConfiguration.loadConfiguration(messagesDE);

        set("Plugin.SoundNotFound", MSG.DE_SoundNotFound, yamlConfigurationDE);
        set("Plugin.NoPermission", MSG.DE_NoPermission, yamlConfigurationDE);
        set("Plugin.PlayerMustBeOnlineToOp", MSG.DE_PlayerMustBeOnlineToOp, yamlConfigurationDE);
        set("Plugin.Reload.Start", MSG.DE_ReloadStart, yamlConfigurationDE);
        set("Plugin.Reload.End", MSG.DE_ReloadEnd, yamlConfigurationDE);

        set("OP_Whitelist.opCommand", MSG.DE_OP_opCommand, yamlConfigurationDE);
        set("OP_Whitelist.consoleOnJoin", MSG.DE_OP_consoleOnJoin, yamlConfigurationDE);
        set("OP_Whitelist.deop", MSG.DE_OP_deop, yamlConfigurationDE);
        set("OP_Whitelist.consoleDeop", MSG.DE_OP_consoleDeop, yamlConfigurationDE);
        set("OP_Whitelist.kick", MSG.DE_OP_kick, yamlConfigurationDE);
        set("OP_Whitelist.consoleKick", MSG.DE_OP_consoleKick, yamlConfigurationDE);
        set("Permission_Whitelist.consoleOnJoin", MSG.DE_Perm_consoleOnJoin, yamlConfigurationDE);
        set("Permission_Whitelist.kick", MSG.DE_Perm_kick, yamlConfigurationDE);
        set("Permission_Whitelist.consoleKick", MSG.DE_Perm_consoleKick, yamlConfigurationDE);
        set("Console.ExactKickReason", MSG.DE_ExactKickReason, yamlConfigurationDE);


        try {
            yamlConfigurationDE.save(messagesDE);
        } catch (IOException e) {
            e.printStackTrace();
        }

        File messagesEN = new File(Main.getPath(), "languages/english_messages.yml");
        YamlConfiguration yamlConfigurationEN = YamlConfiguration.loadConfiguration(messagesEN);

        set("Plugin.SoundNotFound", MSG.EN_SoundNotFound, yamlConfigurationEN);
        set("Plugin.NoPermission", MSG.EN_NoPermission, yamlConfigurationEN);
        set("Plugin.PlayerMustBeOnlineToOp", MSG.EN_PlayerMustBeOnlineToOp, yamlConfigurationEN);
        set("Plugin.Reload.Start", MSG.EN_ReloadStart, yamlConfigurationEN);
        set("Plugin.Reload.End", MSG.EN_ReloadEnd, yamlConfigurationEN);

        set("OP_Whitelist.opCommand", MSG.EN_OP_opCommand, yamlConfigurationEN);
        set("OP_Whitelist.consoleOnJoin", MSG.EN_OP_consoleOnJoin, yamlConfigurationEN);
        set("OP_Whitelist.deop", MSG.EN_OP_deop, yamlConfigurationEN);
        set("OP_Whitelist.consoleDeop", MSG.EN_OP_consoleDeop, yamlConfigurationEN);
        set("OP_Whitelist.kick", MSG.EN_OP_kick, yamlConfigurationEN);
        set("OP_Whitelist.consoleKick", MSG.EN_OP_consoleKick, yamlConfigurationEN);
        set("Permission_Whitelist.consoleOnJoin", MSG.EN_Perm_consoleOnJoin, yamlConfigurationEN);
        set("Permission_Whitelist.kick", MSG.EN_Perm_kick, yamlConfigurationEN);
        set("Permission_Whitelist.consoleKick", MSG.EN_Perm_consoleKick, yamlConfigurationEN);
        set("Console.ExactKickReason", MSG.EN_ExactKickReason, yamlConfigurationEN);

        try {
            yamlConfigurationEN.save(messagesEN);
        } catch (IOException e) {
            e.printStackTrace();
        }

        File messagesNO = new File(Main.getPath(), "languages/norwegian_messages.yml");
        YamlConfiguration yamlConfigurationNO = YamlConfiguration.loadConfiguration(messagesNO);

        set("Plugin.SoundNotFound", MSG.NO_SoundNotFound, yamlConfigurationNO);
        set("Plugin.NoPermission", MSG.NO_NoPermission, yamlConfigurationNO);
        set("Plugin.PlayerMustBeOnlineToOp", MSG.NO_PlayerMustBeOnlineToOp, yamlConfigurationNO);
        set("Plugin.Reload.Start", MSG.NO_ReloadStart, yamlConfigurationNO);
        set("Plugin.Reload.End", MSG.NO_ReloadEnd, yamlConfigurationNO);

        set("OP_Whitelist.opCommand", MSG.NO_OP_opCommand, yamlConfigurationNO);
        set("OP_Whitelist.consoleOnJoin", MSG.NO_OP_consoleOnJoin, yamlConfigurationNO);
        set("OP_Whitelist.deop", MSG.NO_OP_deop, yamlConfigurationNO);
        set("OP_Whitelist.consoleDeop", MSG.NO_OP_consoleDeop, yamlConfigurationNO);
        set("OP_Whitelist.kick", MSG.NO_OP_kick, yamlConfigurationNO);
        set("OP_Whitelist.consoleKick", MSG.NO_OP_consoleKick, yamlConfigurationNO);
        set("Permission_Whitelist.consoleOnJoin", MSG.NO_Perm_consoleOnJoin, yamlConfigurationNO);
        set("Permission_Whitelist.kick", MSG.NO_Perm_kick, yamlConfigurationNO);
        set("Permission_Whitelist.consoleKick", MSG.NO_Perm_consoleKick, yamlConfigurationNO);
        set("Console.ExactKickReason", MSG.NO_ExactKickReason, yamlConfigurationNO);

        try {
            yamlConfigurationNO.save(messagesNO);
        } catch (IOException e) {
            e.printStackTrace();
        }
        send.console(Util.getPrefix() + " §2Language files were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_.longValue()) + "ms");
    }

    private static void set(String path, String value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }
}
