package de.jatitv.opsecurity.system;

import net.t2code.lib.Spigot.Lib.register.Register;
import org.bukkit.permissions.PermissionDefault;

public class Permissions {
    public static final String key = "opsecurity.";
    public static final String notify = key + "notify";
    public static final String updatemsg = key + "updatemsg";
    public static final String reload = key + "command.reload";
    public static final String info = key + "command.info";
    public static final String help = key + "command.help";

    public static final String admin = key + "admin";
    public static final PermissionDefault op = PermissionDefault.OP;
    public static final PermissionDefault notOp = PermissionDefault.NOT_OP;

    protected static void register() {
        Register.permission(notify, op, Main.plugin);
        Register.permissionDescription(notify,"Players with this permission get the update message when joining if an update is available",Main.plugin);
        Register.permission(updatemsg, op, Main.plugin);
        Register.permission(reload, op, Main.plugin);
        Register.permission(info, op, Main.plugin);
        Register.permission(help, op, Main.plugin);

        Register.permission(admin, op, notify, true, Main.plugin);
        Register.permission(admin, op, updatemsg, true, Main.plugin);
        Register.permission(admin, op, reload, true, Main.plugin);
        Register.permission(admin, op, info, true, Main.plugin);
        Register.permission(admin, op, help, true, Main.plugin);

    }
}
