// This claas was created by JaTiTV

package de.jatitv.opsecurity.system;

import de.jatitv.opsecurity.Util;
import de.jatitv.opsecurity.cmdManagement.CmdExecuter;
import de.jatitv.opsecurity.config.config.ConfigConvert;
import de.jatitv.opsecurity.config.config.CreateConfig;
import de.jatitv.opsecurity.config.languages.LanguagesCreate;
import de.jatitv.opsecurity.config.languages.SelectMessages;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.listener.Events;
import de.jatitv.opsecurity.listener.OPCommand;
import de.jatitv.opsecurity.listener.PlugManCommand;
import de.jatitv.opsecurity.listener.Timer;
import net.t2code.lib.Spigot.Lib.messages.T2CodeTemplate;
import net.t2code.lib.Spigot.Lib.register.Register;
import net.t2code.lib.Spigot.Lib.update.UpdateAPI;
import net.t2code.lib.Spigot.system.Metrics;

import java.util.List;

public class Load {
    public static void onLoad(String prefix, List<String> autor, String version, String spigot, int spigotID, String discord, int bstatsID) {
        Long long_ = T2CodeTemplate.onLoadHeader(prefix, autor, version, spigot, discord);
        UpdateAPI.onUpdateCheck(Main.plugin, prefix, spigot, spigotID, discord);
        Metrics.Bstats(Main.plugin, bstatsID);
        loadReload();
        Permissions.register();
        Main.plugin.getCommand("opsecurity").setExecutor(new CmdExecuter());
        Register.listener(new Events(), Main.plugin);
        Register.listener(new OPCommand(), Main.plugin);
        Register.listener(new PlugManCommand(), Main.plugin);
        T2CodeTemplate.onLoadFooter(prefix, long_);
    }

    public static void loadReload() {
        ConfigConvert.convert();
        try {
            CreateConfig.configCreate();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            SelectConfig.onSelect();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            LanguagesCreate.messagesCreate();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            SelectMessages.selectCreate(Util.getPrefix());
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            SelectConfig.sound();
        } catch (Exception e) {
            e.printStackTrace();
        }

        try {
            Timer.RefreshTimer();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
